]> git.madduck.net Git - code/myrepos.git/blobdiff - mr

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Refactor checking for (type of) Git repository
[code/myrepos.git] / mr
diff --git a/mr b/mr
index 9a33d40b3c2f9949df9c2a4e2ba46b4de2b2609f..c646a3bbbcc2b49c8f06e579285dc80648a2d7b1 100755 (executable)
--- a/mr
+++ b/mr
@@ -30,9 +30,9 @@ B<mr> [options] action [params ...]
 
 B<mr> is a Multiple Repository management tool. It can checkout, update, or
 perform other actions on a set of repositories as if they were one combined
-respository. It supports any combination of subversion, git, cvs, mecurial and
-bzr repositories, and support for other revision control systems can easily be
-added.
+respository. It supports any combination of subversion, git, cvs, mecurial,
+bzr and darcs repositories, and support for other revision control systems can
+easily be added.
 
 B<mr> cds into and operates on all registered repositories at or below your
 working directory. Or, if you are in a subdirectory of a repository that
@@ -160,10 +160,8 @@ recurse into deeper repositories.
 =item -j number
 
 Run the specified number of jobs in parallel. This can greatly speed up
-operations such as updates.
-
-Note that in -j mode, all output of the jobs goes to standard output, even
-output that would normally go to standard error.
+operations such as updates. It is not recommended for interactive
+operations.
 
 =back
 
@@ -231,7 +229,17 @@ mr is run by joey. The second uses the hours_since function
 been at least 12 hours since the last update.
 
   skip = test $(whoami) != joey
-  skip = [ "$1" = update ] && [ $(hours_since "$1") -lt 12 ]
+  skip = [ "$1" = update ] && ! hours_since "$1" 12
+
+=item order
+
+The "order" parameter can be used to override the default ordering of
+repositories. The default order value is 10. Use smaller values to make
+repositories be processed earlier, and larger values to make repositories
+be processed later.
+
+Note that if a repository is located in a subdirectory of another
+repository, ordering it to be processed earlier is not recommended.
 
 =item chain
 
@@ -278,7 +286,6 @@ $SIG{INT}=sub {
 
 $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
 my $config_overridden=0;
-my $directory=getcwd();
 my $verbose=0;
 my $stats=0;
 my $no_recurse=0;
@@ -287,6 +294,7 @@ my %config;
 my %configfiles;
 my %knownactions;
 my %alias;
+my $directory=getcwd();
 
 Getopt::Long::Configure("no_permute");
 my $result=GetOptions(
@@ -302,6 +310,9 @@ if (! $result || @ARGV < 1) {
            "(Use mr help for man page.)\n");
 
 }
+if (! defined $directory) {
+       die("mr: failed to determine working directory\n");
+}
 
 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
 # the config file might be a symlink to elsewhere, and the directory it's
@@ -402,34 +413,55 @@ elsif ($action eq 'register') {
        exec($command) || die "exec: $!";
 }
 
+# an ordered list of repos
+my @list;
+foreach my $topdir (sort keys %config) {
+       foreach my $subdir (sort keys %{$config{$topdir}}) {
+               push @list, {
+                       topdir => $topdir,
+                       subdir => $subdir,
+                       order => $config{$topdir}{$subdir}{order},
+               };
+       }
+}
+@list = sort {
+               $a->{order}  <=> $b->{order}
+                            ||
+               $a->{topdir} cmp $b->{topdir}
+                            ||
+               $a->{subdir} cmp $b->{subdir}
+       } @list;
+
 # work out what repos to act on
 my @repos;
 my $nochdir=0;
-foreach my $topdir (sort keys %config) {
-       foreach my $subdir (sort keys %{$config{$topdir}}) {
+foreach my $repo (@list) {
+       my $topdir=$repo->{topdir};
+       my $subdir=$repo->{subdir};
+
+       next if $subdir eq 'DEFAULT';
+       my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
+       my $d=$directory;
+       $dir.="/" unless $dir=~/\/$/;
+       $d.="/" unless $d=~/\/$/;
+       next if $no_recurse && $d ne $dir;
+       next if $dir ne $d && $dir !~ /^\Q$d\E/;
+       push @repos, [$dir, $topdir, $subdir];
+}
+if (! @repos) {
+       # fallback to find a leaf repo
+       foreach my $repo (reverse @list) {
+               my $topdir=$repo->{topdir};
+               my $subdir=$repo->{subdir};
+               
                next if $subdir eq 'DEFAULT';
                my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
                my $d=$directory;
                $dir.="/" unless $dir=~/\/$/;
                $d.="/" unless $d=~/\/$/;
-               next if $no_recurse && $d ne $dir;
-               next if $dir ne $d && $dir !~ /^\Q$d\E/;
-               push @repos, [$dir, $topdir, $subdir];
-       }
-}
-if (! @repos) {
-       # fallback to find a leaf repo
-       LEAF: foreach my $topdir (reverse sort keys %config) {
-               foreach my $subdir (reverse sort keys %{$config{$topdir}}) {
-                       next if $subdir eq 'DEFAULT';
-                       my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
-                       my $d=$directory;
-                       $dir.="/" unless $dir=~/\/$/;
-                       $d.="/" unless $d=~/\/$/;
-                       if ($d=~/^\Q$dir\E/) {
-                               push @repos, [$dir, $topdir, $subdir];
-                               last LEAF;
-                       }
+               if ($d=~/^\Q$dir\E/) {
+                       push @repos, [$dir, $topdir, $subdir];
+                       last;
                }
        }
        $nochdir=1;
@@ -489,7 +521,7 @@ sub action { #{{{
                        system("mkdir", "-p", $dir);
                }
        }
-       elsif ($action eq 'update') {
+       elsif ($action =~ /update/) {
                if (! -d $dir) {
                        return action("checkout", $dir, $topdir, $subdir);
                }
@@ -531,14 +563,15 @@ sub action { #{{{
                        print "mr $action: $topdir$subdir\n";
                }
                else {
-                       print "mr $action: $topdir$subdir (in subdir $directory)\n";
+                       my $s=$directory;
+                       $s=~s/^\Q$topdir$subdir\E\/?//;
+                       print "mr $action: $topdir$subdir (in subdir $s)\n";
                }
                my $command="set -e; ".$lib.
                        "my_action(){ $config{$topdir}{$subdir}{$action}\n }; my_action ".
                        join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
                print STDERR "mr $action: running >>$command<<\n" if $verbose;
                my $ret=system($command);
-               print "\n";
                if ($ret != 0) {
                        if (($? & 127) == 2) {
                                print STDERR "mr $action: interrupted\n";
@@ -569,72 +602,83 @@ sub action { #{{{
 } #}}}
 
 # run actions on multiple repos, in parallel
-my %jobs;
 sub mrs { #{{{
        $| = 1;
+       my @active;
        my @fhs;
        my @out;
        my $running=0;
        while (@fhs or @repos) {
                while ($running < $jobs && @repos) {
-                       $SIG{CHLD}='DEFAULT';
                        $running++;
                        my $repo = shift @repos;
-                       my $pid = open(my $fh, "-|");
-                       if (! $pid) {
-                               open(STDERR, ">&STDOUT");
+                       pipe(my $outfh, CHILD_STDOUT);
+                       pipe(my $errfh, CHILD_STDERR);
+                       my $pid;
+                       unless ($pid = fork) {
+                               die "mr $action: cannot fork: $!" unless defined $pid;
+                               open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
+                               open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
+                               close CHILD_STDOUT;
+                               close CHILD_STDERR;
+                               close $outfh;
+                               close $errfh;
                                exit action($action, @$repo);
                        }
-                       $jobs{$pid}=$repo;
-                       push @fhs, $fh;
-                       push @out, "";
-                       $SIG{CHLD}=\&reaper;
-                       reaper();
+                       close CHILD_STDOUT;
+                       close CHILD_STDERR;
+                       push @active, [$pid, $repo];
+                       push @fhs, [$outfh, $errfh];
+                       push @out, ['',     ''];
                }
-               my ($rin, $rout) = ('','', '');
+               my ($rin, $rout) = ('','');
                my $nfound;
-               foreach my $x (@fhs) {
-                       next unless defined $x;
-                       vec($rin, fileno($x), 1) = 1;
+               foreach my $fh (@fhs) {
+                       next unless defined $fh;
+                       vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
+                       vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
                }
                $nfound = select($rout=$rin, undef, undef, 1);
-               foreach my $i (0..$#fhs) {
-                       my $fh = $fhs[$i];
-                       next unless defined $fh;
-                       if (vec($rout, fileno($fh), 1) == 1) {
-                               my $r = '';
-                               if (sysread($fh, $r, 1024) == 0) {
-                                       close($fh);
-                                       $fhs[$i] = undef;
-                                       $running--;
-                                       print $out[$i];
-                                       $out[$i]='';
+               foreach my $channel (0, 1) {
+                       foreach my $i (0..$#fhs) {
+                               next unless defined $fhs[$i];
+                               my $fh = $fhs[$i][$channel];
+                               next unless defined $fh;
+                               if (vec($rout, fileno($fh), 1) == 1) {
+                                       my $r = '';
+                                       if (sysread($fh, $r, 1024) == 0) {
+                                               close($fh);
+                                               $fhs[$i][$channel] = undef;
+                                               if (! defined $fhs[$i][0] &&
+                                                   ! defined $fhs[$i][1]) {
+                                                       waitpid($active[$i][0], 0);
+                                                       print STDOUT $out[$i][0];
+                                                       print STDERR $out[$i][1];
+                                                       record($active[$i][1], $? >> 8);
+                                                       splice(@fhs, $i, 1);
+                                                       splice(@active, $i, 1);
+                                                       splice(@out, $i, 1);
+                                                       $running--;
+                                               }
+                                       }
+                                       $out[$i][$channel] .= $r;
                                }
-                               $out[$i] .= $r;
                        }
                }
-               while (@fhs and !defined $fhs[0]) {
-                       shift @fhs;
-                       shift @out;
-               }
        }
 } #}}}
 
-sub reaper { #{{{
-       while ((my $pid = waitpid(-1, &WNOHANG)) > 0) {
-               record($jobs{$pid}, $? >> 8) if exists $jobs{$pid};
-       }
-} #}}}
-               
 sub record { #{{{
        my $dir=shift()->[0];
        my $ret=shift;
 
        if ($ret == OK) {
                push @ok, $dir;
+               print "\n";
        }
        elsif ($ret == FAILED) {
                push @failed, $dir;
+               print "\n";
        }
        elsif ($ret == SKIPPED) {
                push @skipped, $dir;
@@ -885,13 +929,17 @@ ci = commit
 ls = list
 
 [DEFAULT]
+order = 10
 lib =
        error() {
                echo "mr: $@" >&2
                exit 1
        }
        hours_since() {
-               for dir in .git .svn .bzr CVS .hg; do
+               if [ -z "$1" ] || [ -z "$2" ]; then
+                       error "mr: usage: hours_since action num"
+               fi
+               for dir in .git .svn .bzr CVS .hg _darcs; do
                        if [ -e "$MR_REPO/$dir" ]; then
                                flagfile="$MR_REPO/$dir/.mr_last$1"
                                break
@@ -900,32 +948,64 @@ lib =
                if [ -z "$flagfile" ]; then
                        error "cannot determine flag filename"
                fi
-               perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile"
-               touch "$flagfile"
+               delta=$(perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile")
+               if [ "$delta" -lt "$2" ]; then
+                       exit 0
+               else
+                       touch "$flagfile"
+                       exit 1
+               fi
+       }
+       get_git_repo_type()
+       {
+               if [ -d "$1"/.git ] && [ -d "$1"/.git/refs/heads ] &&
+                       [ -d "$1"/.git/objects ] && [ -f "$1"/.git/config ];
+                       then
+                       echo non-bare
+               elif [ -d "$1"/refs/heads ] && [ -d "$1"/refs/tags ] &&
+                       [ -d "$1"/objects ] && [ -f "$1"/config ]; then
+                       local bare
+                       bare="$(GIT_CONFIG="$1"/config git-config --get core.bare)"
+                       case "$bare" in
+                               true) echo bare;;
+                               false) echo fake-bare;;
+                               *) return 255;;
+                       esac
+               else
+                       return 1
+               fi
+       }
+       is_git_repo() {
+               get_git_repo_type "$1" >/dev/null
        }
 
 update =
        if [ -d "$MR_REPO"/.svn ]; then
                svn update "$@"
-       elif [ -d "$MR_REPO"/.git ]; then
-               if [ -z "$@" ]; then
-                       git pull -t origin master
-               else
-                       git pull "$@"
-               fi
+       elif is_git_repo "$MR_REPO"; then
+               # all this is because of a bug in git-fetch, which requires GIT_DIR set
+               local git_dir_override; git_dir_override=.git
+               case "$(get_git_repo_type "$MR_REPO")" in
+                       fake-bare) git_dir_override="$MR_REPO";;
+               esac
+               args="$@"
+               [ -z "$args" ] && args="-t origin master"
+               eval GIT_DIR="$git_dir_override" git pull "$args"
        elif [ -d "$MR_REPO"/.bzr ]; then
                bzr merge "$@"
        elif [ -d "$MR_REPO"/CVS ]; then
                cvs update "$@"
        elif [ -d "$MR_REPO"/.hg ]; then
                hg pull "$@" && hg update "$@"
+       elif [ -d "$MR_REPO"/_darcs ]; then
+               darcs pull -a "$@"
        else
                error "unknown repo type"
        fi
 status =
        if [ -d "$MR_REPO"/.svn ]; then
                svn status "$@"
-       elif [ -d "$MR_REPO"/.git ]; then
+       elif is_git_repo "$MR_REPO"; then
                git status "$@" || true
        elif [ -d "$MR_REPO"/.bzr ]; then
                bzr status "$@"
@@ -933,13 +1013,19 @@ status =
                cvs status "$@"
        elif [ -d "$MR_REPO"/.hg ]; then
                hg status "$@"
+       elif [ -d "$MR_REPO"/_darcs ]; then
+               darcs whatsnew -ls "$@"
        else
                error "unknown repo type"
        fi
 commit =
        if [ -d "$MR_REPO"/.svn ]; then
                svn commit "$@"
-       elif [ -d "$MR_REPO"/.git ]; then
+       elif is_git_repo "$MR_REPO"; then
+               case "$(get_git_repo_type "$MR_REPO")" in
+                       bare) error "cannot commit to bare git repositories";;
+                       fake-bare) error "commit does not work for fake bare git repositories (yet).";;
+               esac
                git commit -a "$@" && git push --all
        elif [ -d "$MR_REPO"/.bzr ]; then
                bzr commit "$@" && bzr push
@@ -947,13 +1033,19 @@ commit =
                cvs commit "$@"
        elif [ -d "$MR_REPO"/.hg ]; then
                hg commit -m "$@" && hg push
+       elif [ -d "$MR_REPO"/_darcs ]; then
+               darcs commit -a -m "$@" && darcs push -a
        else
                error "unknown repo type"
        fi
 diff =
        if [ -d "$MR_REPO"/.svn ]; then
                svn diff "$@"
-       elif [ -d "$MR_REPO"/.git ]; then
+       elif is_git_repo "$MR_REPO"; then
+               case "$(get_git_repo_type "$MR_REPO")" in
+                       bare) error "cannot diff in bare git repositories";;
+                       fake-bare) error "diff does not work for fake bare git repositories (yet).";;
+               esac
                git diff "$@"
        elif [ -d "$MR_REPO"/.bzr ]; then
                bzr diff "$@"
@@ -961,13 +1053,15 @@ diff =
                cvs diff "$@"
        elif [ -d "$MR_REPO"/.hg ]; then
                hg diff "$@"
+       elif [ -d "$MR_REPO"/_darcs ]; then
+               darcs diff "$@"
        else
                error "unknown repo type"
        fi
 log =
        if [ -d "$MR_REPO"/.svn ]; then
                svn log"$@"
-       elif [ -d "$MR_REPO"/.git ]; then
+       elif is_git_repo "$MR_REPO"; then
                git log "$@"
        elif [ -d "$MR_REPO"/.bzr ]; then
                bzr log "$@"
@@ -975,6 +1069,8 @@ log =
                cvs log "$@"
        elif [ -d "$MR_REPO"/.hg ]; then
                hg log "$@"
+       elif [ -d "$MR_REPO"/_darcs ]; then
+               darcs changes "$@"
        else
                error "unknown repo type"
        fi
@@ -990,12 +1086,33 @@ register =
                fi
                echo "Registering svn url: $url in $MR_CONFIG"
                mr -c "$MR_CONFIG" config "$(pwd)" checkout="svn co $url $basedir"
-       elif [ -d .git ]; then
-               url=$(LANG=C git-config --get remote.origin.url)
+       elif is_git_repo .; then
+               local repo_type; repo_type="$(get_git_repo_type .)"
+               local config;
+               case "$repo_type" in
+                       non-bare) config=.git/config;;
+                       bare|fake-bare) config=config;;
+                       *) error "unknown git repository type: $repo_type"
+               esac
+               url="$(LANG=C GIT_CONFIG="$config" git-config --get remote.origin.url)"
                if [ -z "$url" ]; then
                        error "cannot determine git url"
                fi
-               echo "Registering git url: $url in $MR_CONFIG"
+               case "$repo_type" in
+                       bare|fake-bare)
+                               # this seems like a bare repo as it has no
+                               # worktree.
+                               local work_tree
+                               work_tree="$(git-config --get core.worktree)" || :
+                               if [ ! -d "$work_tree" ]; then
+                                       error "git worktree $work_tree does not exist"
+                               fi
+                               suffix=" (with worktree $work_tree)"
+                               mr -c "$MR_CONFIG" config "$(pwd)" \
+                                       lib="GIT_WORK_TREE=$work_tree; export GIT_WORK_TREE"
+                               ;;
+               esac
+               echo "Registering git url: $url in $MR_CONFIG${suffix:-}"
                mr -c "$MR_CONFIG" config "$(pwd)" checkout="git clone $url $basedir"
        elif [ -d .bzr ]; then
                url=$(cat .bzr/branch/parent)
@@ -1018,6 +1135,11 @@ register =
                echo "Registering mercurial repo url: $url in $MR_CONFIG"
                mr -c "$MR_CONFIG" config "$(pwd)" \
                        checkout="hg clone $url $basedir"
+       elif [ -d _darcs ]; then
+               url=$(cat _darcs/prefs/defaultrepo)
+               echo "Registering darcs repository $url in $MR_CONFIG"
+               mr -c "$MR_CONFIG" config "$(pwd)" \
+                       checkout="darcs get $url $basedir"
        else
                error "unable to register this repo type"
        fi
@@ -1033,3 +1155,5 @@ ed = echo "A horse is a horse, of course, of course.."
 T = echo "I pity the fool."
 right = echo "Not found."
 #}}}
+
+# vim:sw=8:sts=0:ts=8:noet